var nvrDevice;	//use make new device
////////////// class NVRDevice
// _model;
// _name;
// _supportedCodec;
// _supportHDD;
// _supportMaxResolution;
// _maxSingleIPS;
// _maxTotalIPS;
// _maxSingleBitrate;
// _maxTotalLiveStreamBitrate
// _maxTotalBitrate;
// _supportLive;
// _maxStreamCount;
// _maxChannelCount;
// _defaultCodec;
// _defaultResolution;
// _defaultFramelate;
// _defaultQuality;
//////////////////////////////////

// Bitrate Unit - byte
// 1M == 1024076 byte


/*********************************************************************
*	NVR Model DR-2104P
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-2104P",	// _model
	"DR-2104P",	// _name
	["H.264"],	// _supportedCodec
	[1024,2048,3072,4096,5120,6144],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	120,	// _maxTotalIPS
	[2048,4096, 6144, 8192],	// _maxSingleBitrate on Quality
	32000, //_maxTotalLiveStreamBitrate
	20000, //_maxTotalRemoteStreamBitrate
	33554,	// _maxTotalBitrate
	7,	// _supportLive
	8,	// _maxStreamCount
	4,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080",],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-2108P
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-2108P",	// _model
	"DR-2108P",	// _name
	["H.264"],	// _supportedCodec
	[1024,2048,3072,4096,5120,6144],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[2048,4096, 6144, 8192],	// _maxSingleBitrate on Quality
	32000, //_maxTotalLiveStreamBitrate
	20000, //_maxTotalRemoteStreamBitrate
	67108,	// _maxTotalBitrate
	7,	// _supportLive
	16,	// _maxStreamCount
	8,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-2116P
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-2116P",	// _model
	"DR-2116P",	// _name
	["H.264"],	// _supportedCodec
	[1024,2048,3072,4096,5120,6144],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	32000, //_maxTotalLiveStreamBitrate
	20000, //_maxTotalRemoteStreamBitrate
	66060,	// _maxTotalBitrate
	7,	// _supportLive
	32,	// _maxStreamCount
	16,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
3	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4108(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4108(P)",	// _model
	"DR-4108(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	73400320,	// _maxTotalBitrate
	7,	// _supportLive
	16,	// _maxStreamCount
	8,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4116(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4116(P)",	// _model
	"DR-4116(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	136314880,	// _maxTotalBitrate
	7,	// _supportLive
	32,	// _maxStreamCount
	16,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
1	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4132P
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4132P",	// _model
	"DR-4132P",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	136314880,	// _maxTotalBitrate
	7,	// _supportLive
	64,	// _maxStreamCount
	32,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
4	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4208(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4208(P)",	// _model
	"DR-4208(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	73400320,	// _maxTotalBitrate
	7,	// _supportLive
	16,	// _maxStreamCount
	8,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4216(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4216(P)",	// _model
	"DR-4216(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	136314880,	// _maxTotalBitrate
	7,	// _supportLive
	32,	// _maxStreamCount
	16,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
1	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-4232P
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-4232P",	// _model
	"DR-4232P",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 24576, 36864],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	136314880,	// _maxTotalBitrate
	7,	// _supportLive
	64,	// _maxStreamCount
	32,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
4	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6108(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6108(P)",	// _model
	"DR-6108(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	102407600,	// _maxTotalBitrate
	7,	// _supportLive
	16,	// _maxStreamCount
	8,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6116(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6116(P)",	// _model
	"DR-6116(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	20000, //_maxTotalRemoteStreamBitrate
	204815200,	// _maxTotalBitrate
	7,	// _supportLive
	32,	// _maxStreamCount
	16,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6132(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6132(P)",	// _model
	"DR-6132(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	20000, //_maxTotalRemoteStreamBitrate
	204815200,	// _maxTotalBitrate
	7,	// _supportLive
	64,	// _maxStreamCount
	32,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
2	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6208(P)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6208(P)",	// _model
	"DR-6208(P)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	240,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	102407600,	// _maxTotalBitrate
	7,	// _supportLive
	16,	// _maxStreamCount
	8,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6216(P/PS)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6216(P/PS)",	// _model
	"DR-6216(P/PS)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	204815200,	// _maxTotalBitrate
	7,	// _supportLive
	32,	// _maxStreamCount
	16,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
0	 // _model_group
);
g_nvr_device_list.push(nvrDevice);



/*********************************************************************
*	NVR Model DR-6232(P/PS)
*********************************************************************/
nvrDevice = new NVRDevice(
	"DR-6232(P/PS)",	// _model
	"DR-6232(P/PS)",	// _name
	["H.264"],	// _supportedCodec
	[1024, 2048, 3072, 6144, 12288, 18432, 43008, 67584],	// _supportHDD
	"1920x1080",	// _supportMaxResolution
	[30,30,30,30,30,15],	// _maxSingleIPS on Resolution
	480,	// _maxTotalIPS
	[4096, 6144, 8192, 10240],	// _maxSingleBitrate on Quality
	48000, //_maxTotalLiveStreamBitrate
	50000, //_maxTotalRemoteStreamBitrate
	204815200,	// _maxTotalBitrate
	7,	// _supportLive
	64,	// _maxStreamCount
	32,	// _maxChannelCount
	["H.264","H.264","H.264","H.264"],	// _defaultCodec
	["1920x1080","1920x1080","1920x1080","1920x1080"],	// _defaultResolution
	["30","30","30","30"],	// _defaultFramerate
	["Very High","Very High","Very High","Very High"],	// _defaultQuality
2	 // _model_group
);
g_nvr_device_list.push(nvrDevice);
